#include <bits/stdc++.h>
using namespace std;

int main()
{
    int T; cin>>T;
    int T1=T;
    bool tacno[T];
    while(T>0){
        int N; cin>>N; //broj ucenika
    unsigned long long int M; cin>>M; //broj banana;
    int K; cin>>K; //broj grupa
    int prvaGrupa=N-K;
    int dovoljnoA[K/2];
    int dovoljnoB[K/2];
    int ostali=K-1;
    int ostatak=0;
    bool dobroje=true;
    int br=0;
    unsigned long long int zaOstale=K-1;
    unsigned long long int zaPrvuGrupu= M-(K-1);
    
    while(zaPrvuGrupu % prvaGrupa!=0){
        zaPrvuGrupu--;
        zaOstale++;
    }
    if(zaPrvuGrupu % prvaGrupa==0){
        if(prvaGrupa%2==1  ){
            //zaPrvuGrupu/K 50/5=10 10 11 9 12 8 
            ostatak= zaPrvuGrupu/prvaGrupa;
            int ostatakA=ostatak;
            int ostatakB= ostatak;
            for(int i =0, j=1; i<prvaGrupa/2; i++, j++){
                dovoljnoA[i]= ostatakA-j;
            }
            for(int i =0, j=1; i<prvaGrupa/2; i++, j++){
                dovoljnoB[i]= ostatakB+j;
            }
            
        }
    }
    int ukupno=0;
    for(int i=0;i<prvaGrupa/2; i++){
        ukupno = dovoljnoB[i]+dovoljnoA[i] + ukupno;
    }
    /*cout<<ukupno+ostatak; ukupno za prvu grupu*/
    int i=0;
    while(i<prvaGrupa/2 && dobroje == true){
        if((dovoljnoA[i] != dovoljnoA[i+1]) &&(dovoljnoB[i] != dovoljnoB[i+1] ) && (dovoljnoA[i] != 0) && (dovoljnoB[i] != 0)){
            dobroje=true;
        }else{
            dobroje=false;
        }
        i++;
    }
    
    if(((ukupno+ostatak+zaOstale) == M)&& (dobroje == true) && dovoljnoA[0]>0){
        tacno[T]= true;
    }else{
        tacno[T]= false;
    }
    T--;

    }
    for(int i =T1; i>0; i--){
        cout<<(tacno[i] ? "Tak" : "Nie")<<endl;
    }
    
}